import * as Y from "yjs";
import { MissionMap } from "../storage/missionMap";

export default abstract class MissionDocHelper {
  public static async populateDoc(missionId: string) {
    // get Data from database
    const doc = new Y.Doc();
    doc.getMap("form");
    doc.getText("editor");

    // const ymap = ydoc.getMap('myMap');
    // ymap.set('titel', 'Mein Dokument');
    // ymap.set('inhalt', 'Hier ist der initiale Inhalt');
    // ymap.set('erstelltAm', new Date().toISOString());

    // const yarray = ydoc.getArray('meineArray');
    // yarray.push(['Element 1', 'Element 2', 'Element 3']);

    // const ytext = ydoc.getText('meinText');
    // ytext.insert(0, 'Hier ist ein initialer Text');

    MissionMap.write(missionId, {
      missionId,
      doc,
      editors: new Map(),
      editorStates: new Map(),
      timestamp: 0,
    });
    console.log(`created local doc ${missionId}`);
  }

  public static docAsUpdate(missionId: string): Uint8Array {
    const mission = MissionMap.read(missionId);
    return Y.encodeStateAsUpdate(mission.doc);
  }

  public static docAsStateVector(missionId: string): Uint8Array {
    const mission = MissionMap.read(missionId);
    return Y.encodeStateVector(mission.doc);
  }

  public static docTimestamp(missionId: string): number {
    const mission = MissionMap.read(missionId);
    return mission.timestamp;
  }

  public static getAwarenessState(missionId: string) {
    const mission = MissionMap.read(missionId);
    return Array.from(mission.editorStates.entries());
  }

  public static getAwarenessEditors(missionId: string) {
    const mission = MissionMap.read(missionId);
    return Array.from(mission.editors.entries());
  }

  public static async saveDoc(missionId: string, update: Uint8Array) {
    MissionMap.updateState(missionId, update);
    const mission = MissionMap.read(missionId);
    // store Data to database
  }
}
